设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 42|回复: 1

[工具] 【工具】批量原地旋转对象(以自身的几何中心)

[复制链接]

已领礼包: 20个

财富等级: 恭喜发财

发表于 6 天前 | 显示全部楼层 |阅读模式
  • 插件名称 : 原地旋转
  • 作  者 : marting
  • 运行环境 :XDRX API 晓东工具箱 
  • 发布时间 :2020-06-28
  • 命令名称 :xdtb_rotori
  • 插件介绍 :【工具】批量原地旋转对象(以自身的几何中心)
  • 备  注 : (点击图片可以放大)
(点击图片可以放大)

晓东温馨提示 1、运行环境为 晓东工具箱XDRX API 的插件,请下载最新版本的 晓东工具箱XDRX API开发环境 一键安装
2、在ACAD中如何加载插件,请看 论坛插件使用方法
3、如果您有要求需要定制插件,请到 编程申请 论坛发帖求助

插件详细内容

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
  1. (defun c:xdtb_rotori (/ ss p1 p2 x t1 t2 mat scl)
  2.   (if (setq ss
  3.              (xdrx-ssget
  4.                "\n*** 图元原地缩放((物体中心为基点)) ***\n选择要旋转的对象<退出>:"
  5.              )
  6.       )
  7.     (progn
  8.       (xdrx-begin)
  9.       (setvar "lastpoint" '(0 0 0))
  10.       (xdrx-sysvar-push '("osmode" 33))
  11.       (if (and (xdrx-initget 1 "R")
  12.                (setq p0 (getvar "lastpoint"))
  13.                (setq
  14.                  p1 (getreal (xdrx-prompt "\n请输入旋转角度或[参照(R)]" t))
  15.                )
  16.           )
  17.         (progn
  18.           (cond
  19.             ((= p1 "R")
  20.              (setq pp (getvar "lastpoint"))
  21.              (if (and (setq t1 (getpoint "\n指定参照第一点: <退出>"))
  22.                       (not (initget 1))
  23.                       (setq t2 (getpoint t1 "\n指定第二点:"))
  24.                       (setq d1 (getpoint "\n指定目标第一点:"))
  25.                       (not (initget 1))
  26.                       (setq d2 (getpoint d1 "\n指定第二点:"))
  27.                  )
  28.                (setq scl (xdrx-vector-angle
  29.                            (xdrx-vector-normalize (mapcar '- t2 t1))
  30.                            (xdrx-vector-normalize (mapcar '- d2 d1))
  31.                          )
  32.                )
  33.              )
  34.             )
  35.             ((= (type p1) 'real) (setq scl (xdrx-math-degtor  p1)))
  36.           )
  37.         )
  38.       )
  39.       (if scl
  40.         (progn (mapcar '(lambda        (x)
  41.                           (setq        mat (xdrx-matrix-setrotation
  42.                                       scl '(0 0 1.0)
  43.                                       (trans (xd::geom:get9pt x 5) 1 0)
  44.                                     )
  45.                           )
  46.                           (xdrx-entity-transform x mat)
  47.                         )
  48.                        (xdrx-pickset->ents ss)
  49.                )
  50.                (xdrx-prompt "\n共原位旋转了 " (sslength ss) " 个对象.")
  51.         )
  52.       )
  53.       (xdrx-sysvar-pop)
  54.       (xdrx-end)
  55.     )
  56.   )
  57.   (princ)
  58. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 243个

财富等级: 日进斗金

发表于 前天 08:26 | 显示全部楼层
很好用的插件,谢谢
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-7-4 20:03 , Processed in 0.122948 second(s), 27 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表